module cpu_code

contains

subroutine VectorSum(a,b,c,size)
  implicit none
  real, dimension(0:size-1) :: a,b,c
  integer, value :: size
  integer :: i
  do i=0,size-1
    c(i)=a(i)+b(i)
  end do
end subroutine VectorSum

end module cpu_code

program exercise03

use cpu_code

implicit none

! define vector size !
integer, parameter :: vector_size = 10000000
real, dimension(0:vector_size-1) :: vector_a
real, dimension(0:vector_size-1) :: vector_b
real, dimension(0:vector_size-1) :: vector_c
real(kind=8) :: timer1,timer2,duration
integer :: i
logical :: success
integer :: error

! CPU code !

call random_seed()

! initialize input vector to 0 !
do i=0,vector_size-1
  call random_number(vector_a(i))
  call random_number(vector_b(i))
end do
! initialize output vector to 0 !
do i=0,vector_size-1
  vector_c(i)=0
end do

call cpu_time(timer1)
call VectorSum(vector_a,vector_b,vector_c,vector_size)
call cpu_time(timer2)
duration=timer2-timer1

! verify results !
success=.true.
do i=0,vector_size-1
  if (abs(vector_a(i)+vector_b(i)-vector_c(i))>1e-5) then
    print *,'computation result is wrong: index=',i, &
        ' expected result=',vector_a(i)*vector_b(i), &      
        'cuda result=', vector_c(i)
    success=.false.
    exit
  end if
end do
if (success) then
  print *,'computation result is correct.'
end if

print *,'duration=',duration,' seconds, performance = ',vector_size/duration,' FLOPS'
print *,'memory bandwidth = ',vector_size*12./duration,' bytes/s'

end program exercise03
